VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Automaton"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Const m_c_StateKey As String = "S"

Private m_colStates As Collection
Private m_objCurrentState As State
Public Event BeforeEvaluate(ByVal DataIn As String)
Public Event AfterEvaluate(ByVal DataOut As String, ByVal Failed As Boolean)
Public Event ChangeState(ByVal OldState As State, ByVal NewState As State)
'
'
'

Public Property Get CurrentState() As State
    Set CurrentState = m_objCurrentState
End Property

Private Property Set CurrentState(ByVal Value As State)
    Set m_objCurrentState = Value
End Property

Public Property Get States() As Collection
    If m_colStates Is Nothing Then
        Set m_colStates = New Collection
    End If
    Set States = m_colStates
End Property

Public Function DefineState(ByRef Instruction As String) As Boolean
    Dim lngPos As Long
    Dim objNewState As State
    Dim blnSuccess As Boolean
    Dim strState As String
    
    'Ignore this statement if it begins with a '
    If Left(Trim(Instruction), 1) <> "'" Then
        lngPos = InStr(Instruction, ",")
        strState = Left(Instruction, lngPos - 1)
        
        Set objNewState = CollectionItem(m_c_StateKey & strState, States)
        If objNewState Is Nothing Then
            Set objNewState = New State
            States.Add objNewState, m_c_StateKey & strState
        End If
        blnSuccess = objNewState.DefineState(Instruction)
        DefineState = blnSuccess
    Else
        DefineState = True
    End If
End Function

Public Sub Reset(Optional ByVal ClearProgram As Boolean = False)
    If ClearProgram Then
        Set m_colStates = Nothing
    End If
    Set CurrentState = Nothing
End Sub

Public Function Evaluate(ByVal Data As String, ByRef NewValue As String, ByRef Direction As String) As Boolean
    'Evaluates the data
    Dim blnSuccess As Boolean
    Dim strNewState As String
    Dim objOldState As State
    
    RaiseEvent BeforeEvaluate(Data)
    
    If CurrentState Is Nothing Then
        'Default the current state
        Set CurrentState = CollectionItem(m_c_StateKey & "0", States)
        If CurrentState Is Nothing Then
            'There is no state zero!!!
            Evaluate = False
            Exit Function
        Else
            RaiseEvent ChangeState(Nothing, CurrentState)
        End If
    End If
    
    blnSuccess = CurrentState.Evaluate(Data, NewValue, strNewState, Direction)
    If blnSuccess Then
        'Set the new state
        If strNewState <> CurrentState.StateId Then
            Set objOldState = CurrentState
            Set CurrentState = CollectionItem(m_c_StateKey & strNewState, States)
            If CurrentState Is Nothing Then
                blnSuccess = False
            Else
                RaiseEvent ChangeState(objOldState, CurrentState)
            End If
        End If
    End If
    Evaluate = blnSuccess
    
    RaiseEvent AfterEvaluate(NewValue, Not blnSuccess)
End Function
