VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "State"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Const m_c_InstructionKey As String = "I"

Private m_strStateId As String
Private m_colInstructions As Collection
Public Event BeforeEvaluate(ByVal DataIn As String)
Public Event AfterEvaluate(ByVal DataOut As String, ByVal Failed As Boolean)
Public Event Evaluate(ByVal Instruction As Instruction)
'
'
'

Public Property Get StateId() As String
    StateId = m_strStateId
End Property

Private Property Let StateId(ByVal Value As String)
    m_strStateId = Value
End Property

Public Property Get Instructions() As Collection
    If m_colInstructions Is Nothing Then
        Set m_colInstructions = New Collection
    End If
    Set Instructions = m_colInstructions
End Property

Public Function Evaluate(ByVal DataIn As String, ByRef DataOut As String, ByRef NewState As String, ByRef Direction As String) As Boolean
    'Evaluates the data for this state
    Dim objInstruction As Instruction
    
    RaiseEvent BeforeEvaluate(DataIn)
    
    'Locate the instruction for this data
    Set objInstruction = CollectionItem(m_c_InstructionKey & DataIn, Instructions)
    If objInstruction Is Nothing Then
        Evaluate = False
    Else
        RaiseEvent Evaluate(objInstruction)
        DataOut = objInstruction.DataOut
        NewState = objInstruction.NewState
        Direction = objInstruction.Direction
        Evaluate = True
    End If
    
    RaiseEvent AfterEvaluate(DataOut, Not Evaluate)
End Function

Public Function DefineState(ByVal InstructionLine As String) As Boolean
    'String is expected to be formatted as follows:
    '0, 1, 1, 0, R    ' Skip a 1 and move right.
    Dim objNewInstruction As Instruction
    Dim varCommand As Variant
    Dim lngPos As Long
    
    Set objNewInstruction = New Instruction
    
    'Locate comment if any
    lngPos = InStr(InstructionLine, "'")
    If lngPos > 0 Then
        objNewInstruction.Comment = Trim(Mid(InstructionLine, lngPos + 1))
        InstructionLine = Trim(Left(InstructionLine, lngPos - 1))
    End If
    
    'Break down the program commands
    varCommand = Split(InstructionLine, ",")
    StateId = Trim(varCommand(0))
    objNewInstruction.DataIn = Trim(varCommand(1))
    objNewInstruction.DataOut = Trim(varCommand(2))
    objNewInstruction.NewState = Trim(varCommand(3))
    objNewInstruction.Direction = Trim(varCommand(4))
    
    'Add the instruction if it doesn't already exist
    If CollectionItem(m_c_InstructionKey & objNewInstruction.DataIn, Instructions) Is Nothing Then
        Instructions.Add objNewInstruction, m_c_InstructionKey & objNewInstruction.DataIn
        DefineState = True
    Else
        DefineState = False
    End If
End Function

